    program main
      use mpi

      implicit none

      integer, dimension(:), allocatable :: sendbuf, recvbuf

      integer :: rank, size, ierror
      integer :: i

      call MPI_Init(ierror)
      call MPI_Comm_size(MPI_COMM_WORLD, size, ierror)
      call MPI_Comm_rank(MPI_COMM_WORLD, rank, ierror)

      allocate(sendbuf(size), recvbuf(size))

      do i = 1,size
        sendbuf(i) = (rank * size + i - 1) * 100
      end do

      print 100, rank, sendbuf
100   format('Process ', i0, ' will send:', *(1x,i0))

      call MPI_Alltoall(sendbuf, 1, MPI_INTEGER, recvbuf, 1, MPI_INTEGER, MPI_COMM_WORLD, ierror)

      print 200, rank, recvbuf
200   format('Process ', i0, ' collected values', *(1x,i0))

      deallocate(sendbuf, recvbuf)
      call MPI_Finalize(ierror)
    end program