    program main
      use mpi

      implicit none

      integer :: i, data, ierror
      integer :: rank, bcast_root
    
      call MPI_Init(ierror)
      call MPI_Comm_rank(MPI_COMM_WORLD, rank, ierror)
     
      bcast_root = 0
     
      if (rank .eq. bcast_root) then
        data = 12345
        print 100, rank, data
100     format('I am the broadcast root with rank ', i0, ', and send value ', i0)
      end if
    
      call MPI_Bcast(data, 1, MPI_INT, bcast_root, MPI_COMM_WORLD, ierror)
    
      if (rank .ne. bcast_root) then
        print 200, rank, data
200     format('I am a broadcast receiver with rank ', i0, ' and obtained value ', i0)
      end if
    
      call MPI_Finalize(ierror)
    end program