    program main
      use mpi

      implicit none
      integer :: rank, size
      integer :: right_rank, left_rank
      integer :: recv_buf, send_buf
      integer :: sum, ierror, i
      integer :: status(MPI_STATUS_SIZE)

      call MPI_Init(ierror);

      call MPI_Comm_rank(MPI_COMM_WORLD, rank, ierror)
      call MPI_Comm_size(MPI_COMM_WORLD, size, ierror)

      right_rank = mod(rank+1     , size)
      left_rank  = mod(rank-1+size, size)

      sum = 0
      send_buf = rank

      do i = 1,size
        if (rank .lt. size-1) then
          call MPI_Send(send_buf, 1, MPI_INTEGER, right_rank, 10, MPI_COMM_WORLD, ierror)
          call MPI_Recv(recv_buf, 1, MPI_INTEGER, left_rank, 10, MPI_COMM_WORLD, status, ierror)
        else
          call MPI_Recv(recv_buf, 1, MPI_INTEGER, left_rank, 10, MPI_COMM_WORLD, status, ierror)
          call MPI_Send(send_buf, 1, MPI_INTEGER, right_rank, 10, MPI_COMM_WORLD, ierror)
        end if

        send_buf = recv_buf
        sum = sum + recv_buf
      end do

      print 100, rank, sum
100   format('Process ', i0, ': sum = ', i0)

      call MPI_Finalize(ierror);
    end program