#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>
 
int main(int argc, char* argv[]) {
    MPI_Init(&argc, &argv);
 
    int rank;
    MPI_Comm_rank(MPI_COMM_WORLD, &rank);
 
    printf("Process %d: I start waiting at the barrier.\n", rank);
    MPI_Barrier(MPI_COMM_WORLD);
    printf("Process %d: I'm on the other side of the barrier.\n", rank);
 
    MPI_Finalize();
 
    return 0;
}