    program main
      use mpi

      implicit none

      character(len = 20) :: msg
      integer(4) :: rank, recv_count, ierror, status(MPI_STATUS_SIZE)
      integer(4) :: tag = 99;

      call MPI_Init(ierror)
      call MPI_Comm_rank(MPI_COMM_WORLD, rank, ierror)

      if (rank .eq. 0) then
        msg = 'Hello mate!'
        call MPI_Send(msg, 20, MPI_CHAR, 1, tag, MPI_COMM_WORLD, ierror)

        print 100, rank, msg
100   format('Process ', i0,' send: ', a);
      else if (rank .eq. 1) then
        call MPI_Recv(msg, 20, MPI_CHAR, 0, tag, MPI_COMM_WORLD, status, ierror)
        call MPI_Get_count(status, MPI_CHAR, recv_count, ierror)

        print 200, rank, msg, recv_count
200     format('Process ', i0, ' received: ', a, '(size = ', i0, ')')
      end if

      call MPI_Finalize(ierror)
    end