    program main
      use mpi
     
      implicit none
    
      integer, parameter :: gath_root = 0
    
      integer :: size, rank, ierror, value
      integer, dimension(:), allocatable :: buffer
     
      call MPI_Init(ierror)
      call MPI_Comm_size(MPI_COMM_WORLD, size, ierror)
      call MPI_Comm_rank(MPI_COMM_WORLD, rank, ierror)
     
      value = rank * 100
    
      print 100, rank, value
100   format('Process ', i0, ' has value ', i0, '.')
      
      if (rank .eq. gath_root) allocate(buffer(size))
      
      call MPI_Gather(value, 1, MPI_INTEGER, buffer, 1, MPI_INTEGER, gath_root, MPI_COMM_WORLD, ierror)

      if (rank .eq. gath_root) then
        print 200, rank, buffer
200     format('Values collected on process ', i0, ': ', *(1x,i0), '.')

        deallocate(buffer)
      end if
     
      call MPI_Finalize(ierror)
    end program main