#!/bin/bash
#SBATCH --job-name=mpi-job
#SBATCH --time=00:01:00 # hh:mm:ss
#SBATCH --ntasks=4 #number of MPI processes
#SBATCH --cpus-per-task=1
#SBATCH --mem-per-cpu=2048 # megabytes
#SBATCH --partition=batch
#SBATCH --output=mpi_output.out

module load OpenMPI/3.1.4-GCC-8.3.0
cd $SLURM_SUBMIT_DIR

mpirun -np $SLURM_NTASKS ./your_program